unit IRCON_CMDABOUT;

interface
uses IRCON_Head;

const
    POLYNOMIAL = $8408;
    PRESET_VALUE = $FFFF;

type
    IRCON = class
        class function getCRC(s: string; var crcL, crcH: Byte): Boolean; //CRC,crcLֽ  crcHֽ
        class function checkCmd(var cmd: string; var lastCmd: string): Boolean; overload; //ָǷ(lastCmdΪʣָ
        class function checkCmd(cmd: string): Boolean; overload; //ָǷ(lastCmdΪʣָ
        class function checkCRC(cmd: string): Boolean;      //CRCǷȷ
        class function getCMD(ConAdr, Cmd: Byte; Data: string): string; //ȡ
    end;

implementation
                               
class function IRCON.checkCmd(var cmd: string; var lastCmd: string): Boolean;
var
    cmdLen: Integer;
begin
    result := False;
    if Length(cmd) < 5 then exit;                           //5-23

    cmdLen := Ord(cmd[1]);
    if cmdLen > Length(cmd) then exit;                //ѽָֽյڶָ

    lastCmd := copy(cmd, cmdLen + 1 , Length(cmd));      //ȡʣֽ
    cmd := copy(cmd, 1, cmdLen );

    result := true;
end;

class function IRCON.checkCmd(cmd: string): Boolean;
begin
    result := False;
    if Length(cmd) < 5 then exit;                      //5-23
    if Ord(cmd[1]) <> Length(cmd)  then exit;          //һֽΪĳ˵
    result := true;
end;

class function IRCON.checkCRC(cmd: string): Boolean;
var
    s: string;
    crcL, crcH: Byte;
begin
    result := False;
    if Length(cmd) < 5 then exit;

    s := copy(cmd, 1, Length(cmd) - 2);                     //ȡǰָ
    if not getCRC(s, crcL, crcH) then exit;                 //CRC

    if crcH <> ord(cmd[Length(cmd)]) then  //CRCֽڴ
      exit;
    if crcL <> ord(cmd[Length(cmd) - 1]) then
      exit;             //CRCֽڴ             

    result := true;
end;

class function IRCON.getCMD(ConAdr, Cmd: Byte; Data: string): string;
var
    cmdLen: Byte;
    Command: string;
    crcL, crcH: Byte;
begin
    Command := char(ConAdr) + char(Cmd);
    Command := Command + Data;

    cmdLen := Length(Command) + 3;                          //2ֽڵCRCȱ
    Command := char(cmdLen) + Command;

    getCRC(Command, crcH, crcL);
    result := Command + char(crcH)+ char(crcL);
end;

class function IRCON.getCRC(s: string; var crcL, crcH: Byte): Boolean; //CRC,crcLֽ  crcHֽ
var
    i, j: Integer;
    current_crc_value: Word;
begin
    current_crc_value := PRESET_VALUE;
    for i := 1 to Length(s) do
    begin
        current_crc_value := current_crc_value xor ord(s[i]);
        for j := 0 to 7 do
        begin
            if ((current_crc_value and $0001) <> 0) then
                current_crc_value := (current_crc_value shr 1) xor POLYNOMIAL
            else
                current_crc_value := (current_crc_value shr 1);
        end;
    end;

    crcL := (current_crc_value and $00FF);
    crcH := ((current_crc_value shr 8) and $00FF);

    result := true;
end;

end.

